package br.com.bfisica.dao.sql;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import br.com.bfisica.dao.PersonDAO;
import br.com.bfisica.db.Database;
import br.com.bfisica.entity.Person;

public class PersonDAOSql implements PersonDAO {
	
	Connection conn = Database.getInstance().getConnection();

	//@Override
	public void save(Person person) {
		PreparedStatement pstm;
		try {
			pstm = conn.prepareStatement("insert into PERSON values(?,?)");
			pstm.setInt(1, person.getId());
			pstm.setString(2, person.getNome());
			pstm.execute();
			pstm.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	//@Override
	public void delete(Person person) {
		PreparedStatement pstm;
		try {
			pstm = conn.prepareStatement("delete from PERSON where id=?");
			pstm.setInt(1, person.getId());
			pstm.execute();
			pstm.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}	
	
	//@Override
	public void delete(int id) {
		PreparedStatement pstm;
		try {
			pstm = conn.prepareStatement("delete from PERSON where id=?");
			pstm.setInt(1, id);
			pstm.execute();
			pstm.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	//@Override
	public List<Person> getPersons() {
		
		Person person;
		List<Person> persons = new ArrayList<Person>();
		Statement stmt;
		ResultSet rs;
		
		try {
			stmt = conn.createStatement();
			rs = stmt.executeQuery("select * from PERSON");
			while (rs.next()) {
				person = new Person();
				person.setId(rs.getInt(1));
				person.setName(rs.getString(2));
				persons.add(person);
			}
			stmt.close();
			return persons;
		} catch (SQLException e) {
			e.printStackTrace();
		}

		return null;
	}

	//@Override
	public Person getPersonByID(int id) {
		Person person = new Person();
		PreparedStatement pstm;
		ResultSet rs;
		try {
			pstm = conn.prepareStatement("select * from PERSON where id = ?");
			pstm.setInt(1, id);
			rs = pstm.executeQuery();
			pstm.close();
			while (rs.next()){
				person = new Person();
				person.setId(rs.getInt(1));
				person.setName(rs.getString(2));
			}
			return person;
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}

}
