package br.com.bfisica.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Properties;

import br.com.bfisica.util.MyProperties;

public class Database {
	
	private String dbDriver;
	private String dbUrl;
	private String dbUsername;
	private String dbPassword;
	
	private static Database instance = null;
	private static Connection conn = null;
	
	private Database() {
		init();
		try {
			Class.forName(dbDriver);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		try {
			conn = DriverManager.getConnection(dbUrl, dbUsername, dbPassword);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public static Database getInstance(){
		if (instance == null) {
			return new Database();
		} else {
			return instance;
		}
	}
	
	public static Connection getConnection(){
		return conn;
	}
	
	private void init() {
		Properties props = MyProperties.getInstance().getProperties();
		this.dbDriver = props.getProperty("db.driver");
		this.dbUrl = props.getProperty("db.url");
		this.dbUsername = props.getProperty("db.username");
		this.dbPassword = props.getProperty("db.password");
	}

}
