package br.com.bfisica.util;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;
import org.hibernate.service.ServiceRegistry;
import org.hibernate.service.ServiceRegistryBuilder;

public class HibernateUtil {
	
	private static ServiceRegistry serviceRegistry;
	private static SessionFactory sessionFactory;
	private static Session session;
	private static HibernateUtil instance = null;
	
	private HibernateUtil(){
		init();
	}
	
	public static HibernateUtil getInstance(){
		if (instance == null) {
			instance = new HibernateUtil();
		}
		return instance;
	}
	
	private void init() {
		Configuration cfg = new Configuration();
		cfg.addAnnotatedClass(br.com.bfisica.entity.Person.class);
		//cfg.addClass(br.com.bfisica.entity.Pessoa.class); // In this case it's necessary a Pessoa.hdm.xml
		cfg.configure();
		serviceRegistry = new ServiceRegistryBuilder().applySettings(cfg.getProperties()).buildServiceRegistry();
		sessionFactory = cfg.buildSessionFactory(serviceRegistry);
		session = sessionFactory.getCurrentSession();
	}

 
	public static Session getSession(){  
	      return session;
	   }  

	public static SessionFactory getSessionFactory() {
		return sessionFactory;
	}

}



//cfg.setProperty("hibernate.connection.driver_class", "org.hsqldb.jdbcDriver");  
//cfg.setProperty("hibernate.connection.url", "jdbc:mysql://127.0.0.1:3306/my_db");  
//cfg.setProperty("hibernate.connection.username", "username");  
//cfg.setProperty("hibernate.connection.password", "passw");  
//cfg.setProperty("hibernate.show_sql", "true");  
//cfg.setProperty("hibernate.dialect", "org.hibernate.dialect.MySQL5InnoDBDialect");  
//cfg.setProperty("hibernate.connection.autocommit", "false");  
//cfg.setProperty("hibernate.c3p0.min_size", "5");  
//cfg.setProperty("hibernate.c3p0.max_size", "20");  
//cfg.setProperty("hibernate.c3p0.timeout", "1800");  
//cfg.setProperty("hibernate.c3p0.max_statements", "50");  
//cfg.setProperty("hibernate.hbm2ddl.auto", "none");  
//cfg.setProperty("hibernate.cache.provider_class", "org.hibernate.cache.NoCacheProvider");  
//cfg.setProperty("hibernate.transaction.factory_class", "org.hibernate.transaction.JDBCTransactionFactory");  
//cfg.setProperty("hibernate.current_session_context_class", "thread");  
//cfg.setProperty("hibernate.generate_statistics", "true");
